## masscan 1.0.3-104

=== Makefile ===
PREFIX ?= /usr
BINDIR ?= $(PREFIX)/bin
SYS := $(shell gcc -dumpmachine)
GITVER := $(shell git describe --tags)
INSTALL_DATA := -pDm755

ifeq ($(GITVER),)
GITVER = "unknown"
endif

# LINUX
# The automated regression tests run on Linux, so this is the one
# environment where things likely will work -- as well as anything
# works on the bajillion of different Linux environments
ifneq (, $(findstring linux, $(SYS)))
LIBS = -lpcap -lm -lrt -ldl -lpthread
INCLUDES =
FLAGS2 = 
endif

# MAC OS X
# I occassionally develope code on Mac OS X, but it's not part of
# my regularly regression-test environment. That means at any point
# in time, something might be minorly broken in Mac OS X.
ifneq (, $(findstring darwin, $(SYS)))
LIBS = -lpcap -lm 
INCLUDES = -I.
FLAGS2 = 
INSTALL_DATA = -pm755
endif

# MinGW on Windows
# I develope on Visual Studio 2010, so that's the Windows environment
# that'll work. However, 'git' on Windows runs under MingGW, so one
# day I acccidentally typed 'make' instead of 'git, and felt compelled
# to then fix all the errors, so this kinda works now. It's not the
# intended environment, so it make break in the future.
ifneq (, $(findstring mingw, $(SYS)))
INCLUDES = -Ivs10/include
LIBS = -L vs10/lib -lwpcap -lIPHLPAPI -lWs2_32
FLAGS2 = -march=i686
endif

# Cygwin
# I hate Cygwin, use Visual Studio or MingGW instead. I just put this
# second here for completeness, or in case I gate tired of hitting my
# head with a hammer and want to feel a different sort of pain.
ifneq (, $(findstring cygwin, $(SYS)))
INCLUDES = -I.
LIBS = -lwpcap
FLAGS2 = 
endif

# OpenBSD
ifneq (, $(findstring openbsd, $(SYS)))
LIBS = -lpcap -lm -pthread
INCLUDES = -I.
FLAGS2 = 
endif

# FreeBSD
ifneq (, $(findstring freebsd, $(SYS)))
LIBS = -lpcap -lm -pthread
INCLUDES = -I.
FLAGS2 =
endif

# this works on llvm or real gcc
CC = gcc

DEFINES = 
CFLAGS = -g -ggdb $(FLAGS2) $(INCLUDES) $(DEFINES) -Wall -O3
.SUFFIXES: .c .cpp

all: bin/masscan 


tmp/main-conf.o: src/main-conf.c src/*.h
	$(CC) $(CFLAGS) -c $< -o $@ -DGIT=\"$(GITVER)\"


# just compile everything in the 'src' directory. Using this technique
# means that include file dependencies are broken, so sometimes when
# the program crashes unexpectedly, 'make clean' then 'make' fixes the
# problem that a .h file was out of date
tmp/%.o: src/%.c src/*.h
	$(CC) $(CFLAGS) -c $< -o $@


SRC = $(wildcard src/*.c)
OBJ = $(addprefix tmp/, $(notdir $(addsuffix .o, $(basename $(SRC))))) 


bin/masscan: $(OBJ)
	$(CC) $(CFLAGS) -o $@ $(OBJ) $(LDFLAGS) $(LIBS)

clean:
	rm -f tmp/*.o
	rm -f bin/masscan

regress: bin/masscan
	bin/masscan --selftest

test: regress

install: bin/masscan
	install $(INSTALL_DATA) bin/masscan $(DESTDIR)$(BINDIR)/masscan
	
default: bin/masscan

## masscan 1.0.3-90-g2441f18~ds0

=== debian/changelog ===
masscan (1.0.3-90-g2441f18~ds0-1) unstable; urgency=medium

  * Import new upstream snapshot.

 -- Alessio Treglia <alessio@debian.org>  Wed, 15 Oct 2014 14:06:24 +0100

masscan (1.0.3-82-g6f2d6af~ds0-1) unstable; urgency=medium

  * Initial release. (Closes: #762866)

 -- Alessio Treglia <alessio@debian.org>  Thu, 25 Sep 2014 21:08:16 +0100

=== debian/control ===
Source: masscan
Section: net
Priority: optional
Maintainer: Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper (>= 9~),
 libpcap-dev
Standards-Version: 3.9.5
Homepage: https://github.com/robertdavidgraham/masscan
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/masscan.git
Vcs-Git: git://anonscm.debian.org/collab-maint/masscan.git

Package: masscan
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: TCP port scanner
 MASSCAN is TCP port scanner which transmits SYN packets
 asynchronously and produces results similar to nmap,
 the most famous port scanner. Internally, it operates
 more like scanrand, unicornscan, and ZMap, using
 asynchronous transmission.
 It's a flexible utility that allows arbitrary address and
 port ranges.

## masscan 1.0.3-95-gb395f18~ds0

=== debian/changelog ===
masscan (1.0.3-95-gb395f18~ds0-2) unstable; urgency=medium

  * Attempt to fix FTBFS with GCC 5. (Closes: #777997)

 -- Alessio Treglia <alessio@debian.org>  Fri, 26 Jun 2015 08:33:28 +0100

masscan (1.0.3-95-gb395f18~ds0-1) unstable; urgency=medium

  * ACK NMU. (Closes: #773786)
  * Import new upstream snapshot.
  * Refresh patches.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Wed, 10 Jun 2015 14:19:37 +0100

masscan (1.0.3-90-g2441f18~ds0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on most architectures (Non-ARM, Non-x86, and kFreeBSD).
    (Closes: 773786) 

 -- YunQiang Su <syq@debian.org>  Tue, 31 Mar 2015 11:06:17 +0800

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  debhelper (>= 9~),
  libpcap-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: https://github.com/robertdavidgraham/masscan
 Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/masscan.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/masscan.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DESTDIR=debian/masscan/

%:
	dh $@ --parallel

get-orig-source:
	$(CURDIR)/debian/get-git-source.sh

## masscan 1.0.3-104-g676635d~ds0

=== debian/changelog ===
masscan (2:1.0.3-104-g676635d~ds0-1) unstable; urgency=medium

  * Imported Upstream version 1.0.3-104-g676635d~ds0
  * Drop 0002-gcc5.patch patch
  * Introduce epoch number (Closes: #816644)

 -- Alessio Treglia <alessio@debian.org>  Sat, 05 Mar 2016 18:44:08 +0000

=== debian/watch ===
version=3
# use the github release pages
opts=dversionmangle=s/~ds\d// \
https://github.com/robertdavidgraham/masscan/releases .*/(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## masscan 1.0.5%2Bds1

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 # environment where things likely will work -- as well as anything
 # works on the bajillion of different Linux environments
 ifneq (, $(findstring linux, $(SYS)))
-LIBS = -lpcap -lm -lrt -ldl -lpthread
+LIBS = -lm -lrt -ldl -lpthread
 INCLUDES =
 FLAGS2 = 
 endif
@@ -23,7 +23,7 @@
 # my regularly regression-test environment. That means at any point
 # in time, something might be minorly broken in Mac OS X.
 ifneq (, $(findstring darwin, $(SYS)))
-LIBS = -lpcap -lm 
+LIBS = -lm 
 INCLUDES = -I.
 FLAGS2 = 
 INSTALL_DATA = -pm755
@@ -37,7 +37,7 @@
 # intended environment, so it make break in the future.
 ifneq (, $(findstring mingw, $(SYS)))
 INCLUDES = -Ivs10/include
-LIBS = -L vs10/lib -lwpcap -lIPHLPAPI -lWs2_32
+LIBS = -L vs10/lib -lIPHLPAPI -lWs2_32
 FLAGS2 = -march=i686
 endif
 
@@ -47,26 +47,26 @@
 # head with a hammer and want to feel a different sort of pain.
 ifneq (, $(findstring cygwin, $(SYS)))
 INCLUDES = -I.
-LIBS = -lwpcap
+LIBS = 
 FLAGS2 = 
 endif
 
 # OpenBSD
 ifneq (, $(findstring openbsd, $(SYS)))
-LIBS = -lpcap -lm -pthread
+LIBS = -lm -pthread
 INCLUDES = -I.
 FLAGS2 = 
 endif
 
 # FreeBSD
 ifneq (, $(findstring freebsd, $(SYS)))
-LIBS = -lpcap -lm -pthread
+LIBS = -lm -pthread
 INCLUDES = -I.
 FLAGS2 =
 endif
 
 # this works on llvm or real gcc
-CC = gcc
+CC = clang
 
 DEFINES = 
 CFLAGS = -g -ggdb $(FLAGS2) $(INCLUDES) $(DEFINES) -Wall -O3
@@ -87,7 +87,7 @@
 	$(CC) $(CFLAGS) -c $< -o $@
 
 
-SRC = $(wildcard src/*.c)
+SRC = $(sort $(wildcard src/*.c))
 OBJ = $(addprefix tmp/, $(notdir $(addsuffix .o, $(basename $(SRC)))))

## masscan 1.0.5+ds1

=== debian/changelog ===
masscan (2:1.0.5+ds1-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Remove get-git-source.sh
  * New upstream version 1.0.5+ds1 (Closes: #901596)
      - fixes reproducible build (Closes: #842988)
  * Taking over the maintenance of package with Alessio
    Treglia's permission. Thank you to him for the work
    on the package.
  * Remove old gbp.conf
  * Add missing build-dep clang
  * Update date in d/copyright
  * Fix details in d/copyright for lintian
  * Use debhelper 11
  * Refresh patch
  * Add a patch fix-spelling-errors
  * d/rules: add build hardening
  * Bump Standards-Version to 4.1.4: no change required

  [ Raphaël Hertzog ]
  * Try to manually enable PIE compilation since clang does not enable it by
    default.

 -- Sophie Brun <sophie@freexian.com>  Thu, 28 Jun 2018 11:19:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: masscan
 Section: net
 Priority: optional
-Maintainer: Alessio Treglia <alessio@debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Uploaders: Sophie Brun <sophie@freexian.com>
 Build-Depends:
- debhelper (>= 9~),
+ debhelper (>= 11),
+ clang,
  libpcap-dev
-Standards-Version: 3.9.6
+Standards-Version: 4.1.4
 Homepage: https://github.com/robertdavidgraham/masscan
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/masscan.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/masscan.git
+Vcs-Browser: https://salsa.debian.org/pkg-security-team/masscan
+Vcs-Git: https://salsa.debian.org/pkg-security-team/masscan.git
 
 Package: masscan
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Needed because we use clang and not gcc which does it by default
export DEB_CFLAGS_MAINT_APPEND = -fPIE
export DEB_LDFLAGS_MAINT_APPEND = -fPIE -pie

export DESTDIR=debian/masscan/

%:
	dh $@

## masscan 1.3.0+ds1

=== debian/changelog ===
masscan (2:1.3.0+ds1-2) unstable; urgency=medium

  * Import upstream patch to fix segfault (see
    https://github.com/robertdavidgraham/masscan/issues/539)

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 18 Jan 2021 14:14:36 +0100

masscan (2:1.3.0+ds1-1) unstable; urgency=medium

  [ Sophie Brun ]
  * New upstream version 1.3.0+ds1
  * Update debian/copyright
  * Refresh patches

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.4.1, no changes needed.
  * Update standards version to 4.5.0, no changes needed.

  [ Samuel Henrique ]
  * Add salsa-ci.yml
  * Configure git-buildpackage for Debian

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 11 Jan 2021 15:53:47 +0100

masscan (2:1.0.5+ds1-3) unstable; urgency=medium

  * Add a patch to display the correct version
  * Update my email
  * Use debhelper-compat 12
  * Bump Standards-Version (no change)

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 08 Jul 2019 16:11:13 +0200

masscan (2:1.0.5+ds1-2) unstable; urgency=medium

  * Add a patch to use gcc instead of clang (Closes: #902754)
    - Remove clang in build-deps
    - Remove manual PIE flags as it's useless now

 -- Sophie Brun <sophie@freexian.com>  Wed, 04 Jul 2018 11:51:29 +0200

## masscan 1.3.1+ds1

=== debian/changelog ===
masscan (2:1.3.1+ds1-1) unstable; urgency=medium

  * New upstream version 1.3.1+ds1
  * Refresh patches: remove fix-segfault.patch now in usptream release

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 26 Jan 2021 10:40:08 +0100

## masscan 1.3.2+ds1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,14 @@
+ifneq (, $(shell which clang))
+CC = clang
+else ifneq (, $(shell which gcc))
+CC = gcc
+else
+CC = cc
+endif
+
 PREFIX ?= /usr
 BINDIR ?= $(PREFIX)/bin
-SYS := $(shell gcc -dumpmachine)
+SYS := $(shell $(CC) -dumpmachine)
 GITVER := $(shell git describe --tags)
 INSTALL_DATA := -pDm755
 
@@ -13,7 +21,11 @@
 # environment where things likely will work -- as well as anything
 # works on the bajillion of different Linux environments
 ifneq (, $(findstring linux, $(SYS)))
+ifneq (, $(findstring musl, $(SYS)))
+LIBS = 
+else
 LIBS = -lm -lrt -ldl -lpthread
+endif
 INCLUDES =
 FLAGS2 = 
 endif
@@ -53,23 +65,28 @@
 
 # OpenBSD
 ifneq (, $(findstring openbsd, $(SYS)))
-LIBS = -lm -pthread
+LIBS = -lm -lpthread
 INCLUDES = -I.
 FLAGS2 = 
 endif
 
 # FreeBSD
 ifneq (, $(findstring freebsd, $(SYS)))
-LIBS = -lm -pthread
+LIBS = -lm -lpthread
 INCLUDES = -I.
 FLAGS2 =
 endif
 
-# this works on llvm or real gcc
-CC = clang
+# NetBSD
+ifneq (, $(findstring netbsd, $(SYS)))
+LIBS = -lm -lpthread
+INCLUDES = -I.
+FLAGS2 =
+endif
+
 
 DEFINES = 
-CFLAGS = -g -ggdb $(FLAGS2) $(INCLUDES) $(DEFINES) -Wall -O3
+CFLAGS = -g -ggdb $(FLAGS2) $(INCLUDES) $(DEFINES) -Wall -O2
 .SUFFIXES: .c .cpp
 
 all: bin/masscan

=== debian/changelog ===
masscan (2:1.3.2+ds1-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Team upload.
  * Bump debhelper from old 12 to 13.
  * Update standards version to 4.6.1, no changes needed.

  [ Francisco Vilmar Cardoso Ruviaro ]
  * Run wrap-and-sort -a.
  * Add libpcap0.8t64 to the Depends field because it is needed to
    run the program, see src/main.c +43 and src/stub-pcap.c +391.
  * Update the search rule in debian/watch.

 -- Francisco Vilmar Cardoso Ruviaro <vilmar@debian.org>  Thu, 25 Jul 2024 16:44:22 +0000

masscan (2:1.3.2+ds1-1) unstable; urgency=medium

  * New upstream version 1.3.2+ds1

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 02 Feb 2021 12:13:27 +0100

=== debian/control ===
Source: masscan
Section: net
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13),
               libpcap-dev
Standards-Version: 4.6.1
Homepage: https://github.com/robertdavidgraham/masscan
Vcs-Browser: https://salsa.debian.org/pkg-security-team/masscan
Vcs-Git: https://salsa.debian.org/pkg-security-team/masscan.git

Package: masscan
Architecture: any
Depends: libpcap0.8t64,
         ${misc:Depends},
         ${shlibs:Depends}
Description: TCP port scanner
 MASSCAN is TCP port scanner which transmits SYN packets
 asynchronously and produces results similar to nmap,
 the most famous port scanner. Internally, it operates
 more like scanrand, unicornscan, and ZMap, using
 asynchronous transmission.
 It's a flexible utility that allows arbitrary address and
 port ranges.

=== debian/watch ===
version=4
opts="dversionmangle=s/\~ds\d*$//,repacksuffix=+ds1" \
https://github.com/robertdavidgraham/masscan/tags .*/(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
